/*
  Include de componentes electronicos
*/

#declare largo_placa=20.3

#declare dist_slot=2.8
#declare ancho_slot=0.7
#declare largo_slot=8
#declare grosor_placa=0.1

#declare t_placa=
texture{
 pigment{
  image_map{ gif "i_placa.gif"}
  translate <-0.5,-0.5,0>
  scale <largo_placa,ancho_placa,1>
 }
 normal{
  bump_map{ gif "i_placa.gif" bump_size -1 interpolate 2}
  translate <-0.5,-0.5,0>
  scale <largo_placa,ancho_placa,1>
 }
 finish{Phong_Shiny reflection 0.1}
}
#declare t_slot=
texture{
 pigment{
  image_map{ gif "i_slot.gif"}
  translate <-0.5,-0.5,0>
  scale <largo_slot,ancho_slot,1>
 }
 normal{
  bump_map{ gif "i_slot.gif" bump_size 1 interpolate 2}
  translate <-0.5,-0.5,0>
  scale <largo_slot,ancho_slot,1>
 }
 finish{Metal}
}

#declare placa=
difference{
 box{
  <-largo_placa/2,-ancho_placa/2,-grosor_placa/2>
  < largo_placa/2, ancho_placa/2, grosor_placa/2>
 }
 cylinder{
  <-(largo_placa/2)+0.2,-(ancho_placa/2)+0.15,-grosor_placa>
  <-(largo_placa/2)+0.2,-(ancho_placa/2)+0.15,grosor_placa>
  0.15
 }
 cylinder{
  < (largo_placa/2)+0.2, (ancho_placa/2)+0.15,-grosor_placa>
  < (largo_placa/2)+0.2, (ancho_placa/2)+0.15,grosor_placa>
  0.15
 }
 texture{t_placa}
}
#declare slot=
box{
 <-largo_slot/2,-ancho_slot/2,-grosor_placa/2>
 < largo_slot/2, ancho_slot/2, grosor_placa/2>
 texture{t_slot}
}
#declare placa_base=
union{
 object{ placa }
 object{ slot
   translate <(largo_placa/2)-(largo_slot/2)-dist_slot,-((ancho_placa/2)+(ancho_slot/2)),0>
 }
}

// **** fin placa base *****

/*
  **** conector+chapa ****
  medidas:
                  1.1
                 
                  2.0
             1.6 
            Ŀ
            
                Ŀ
                 
        6.9      
                 
                 
                
            ĿĿ
        0.6 
             1.2 
                 
                 

*/
#declare alto_chapa=12.1
#declare largo_borde=1.1
#declare ancho_chapa=1.3
#declare grosor_chapa=0.08
#declare ancho_conec=1.6
#declare alto_conec=6.2
#declare grosor_conec=1.1
#declare dist_conec=2

#declare t_chapa=
texture{Chrome_Texture}
#declare t_conec=
texture{
 pigment{Black}
 finish{Phong_Dull reflection 0.1}
}

#declare plancha=
union{
 box{
  <-grosor_chapa/2,-alto_chapa/2,-ancho_chapa/2>
  < grosor_chapa/2, alto_chapa/2, ancho_chapa/2>
 }
 box{
  <-grosor_chapa/2,(alto_chapa/2)-(grosor_chapa/2),-ancho_chapa/2>
  <-grosor_chapa/2+ancho_chapa,(alto_chapa/2)+(grosor_chapa/2),ancho_chapa/2>
 }
 texture{t_chapa}
}
#declare conector=
union{
 box{
  <-(grosor_chapa/2)-ancho_conec,0,-grosor_conec/2>
  <-(grosor_chapa/2),alto_conec,grosor_conec/2>
  texture{t_conec}
 }
}

#declare chapa=
union{
 object{plancha}
 object{conector
  translate (-alto_conec/2+0.8)*y
 }
}

// **** fin conector+chapa ****

/*
  **** Distintos tamaos de chips ****
*/
#declare t_silicio=
texture{
 pigment{Flesh}
 finish{Phong_Dull}
}
#declare t_pata_chip=
 texture{Chrome_Texture}

// **** chip mediano ****
#declare t_chip=
texture{
 pigment{
  image_map{
   gif "i_chip_2.gif"
  }
  translate <-.5,-.5,0>
  scale <44/22,18/22,1>
  rotate 180*y
  rotate 90*z
 }
 finish{Dull ambient 0.1}
}
#declare num_patas_chip=12
#declare ancho_chip=0.9
#declare alto_chip=0.2
#declare alto_pata_chip=0.4
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_med=
#include "chipw.inc"

// **** chip pequeo ****
#declare t_chip=
texture{
 pigment{Black}
 finish{Phong_Dull reflection 0.1 roughness 0.4 ambient 0.1}
}
#declare num_patas_chip=4
#declare ancho_chip=0.8
#declare alto_chip=0.16
#declare alto_pata_chip=0.3
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_peq=
#include "chipw.inc"

// **** chip fino y largo 1 ****
#declare num_patas_chip=24
#declare ancho_chip=0.5
#declare alto_chip=0.15
#declare alto_pata_chip=0.3
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_fl1=
#include "chipw.inc"

// **** chip fino y corto ****
#declare num_patas_chip=11
#declare ancho_chip=0.5
#declare alto_chip=0.15
#declare alto_pata_chip=0.3
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_fc=
#include "chipw.inc"

// **** chip corto gordo ****
#declare t_chip=
texture{
 pigment{
  image_map{
   gif "i_chip_3.gif"
  }
  translate <-.5,-.5,0>
  scale <52/22,32/22,1>
  rotate 180*y
  rotate 90*z
 }
 finish{Dull ambient 0.1}
}
#declare num_patas_chip=12
#declare ancho_chip=1.4
#declare alto_chip=0.4
#declare alto_pata_chip=0.6
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_cortog=
#include "chipw.inc"

// **** chip gordo ****
#declare t_chip=
texture{
 pigment{
  image_map{
   gif "i_chip_1.gif"
  }
  translate <-.5,-.5,0>
  scale <90/22,35/22,1>
  rotate 180*y
  rotate 90*z
 }
 finish{Dull reflection 0.1 ambient 0.1}
}
#declare num_patas_chip=22
#declare ancho_chip=1.3
#declare alto_chip=0.3
#declare alto_pata_chip=0.5
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_gordo=
#include "chipw.inc"

// **** chip gordo B ****
#declare t_chip=
texture{
 pigment{
  image_map{
   gif "i_chip1b.gif"
  }
  translate <-.5,-.5,0>
  scale <90/22,35/22,1>
  rotate 180*y
  rotate 90*z
 }
 finish{Phong_Dull reflection 0.1 brilliance 0.3 ambient 0.1}
}
#declare num_patas_chip=22
#declare ancho_chip=1.3
#declare alto_chip=0.3
#declare alto_pata_chip=0.5
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_gordoB=
#include "chipw.inc"

// **** chip gordo C ****
#declare t_chip=
texture{
 pigment{
  image_map{
   gif "i_chip1c.gif"
  }
  translate <-.5,-.5,0>
  scale <90/22,35/22,1>
  rotate 180*y
  rotate 90*z
 }
 finish{Phong_Dull reflection 0.2 roughness 0.5 ambient 0.1}
}
#declare num_patas_chip=22
#declare ancho_chip=1.3
#declare alto_chip=0.3
#declare alto_pata_chip=0.5
#declare ancho_pata_chip=0.1
#declare grosor_pata_chip=0.05
#include "chips.inc"
#declare chip_gordoC=
#include "chipw.inc"

// **** fin chips ****

/*
  **** zocalo basico para chip ****
*/

/*
  **** conmutador dip ****

                                            0.2
    Ŀ    ĿĿ 0.1
    Ŀ   Ŀ
1.0 oĴ               
    n                   0.8
      1  2  3  4  5  6  7  8  9  0      Ŀ 0.1
              
                 2.7                          1*2/4
*/
#declare largo_dip=2.7
#declare ancho_dip=1.0
#declare alto_dip=0.8
#declare ancho_vientre=1*2/4
#declare alto_vientre=0.1
#declare alto_bot=0.1
#declare ancho_bot=0.2
#declare largo_bot=0.11
#declare num_boton=10

#declare t_carcasa_dip=
texture{
 material_map{
  gif "i_dip.gif"
  texture{pigment{Black}}
  texture{pigment{SteelBlue} finish{Dull reflection 0.08}}
 }
 translate <-.5,-.5,0>
 scale <55/22,22/22,1>
}
#declare t_boton_dip=
texture{
 pigment{White}
 finish{Phong_Dull}
}

#declare carcasa_dip=
difference{
 box{
  <-largo_dip/2,-ancho_dip/2,-alto_dip/2>
  < largo_dip/2, ancho_dip/2, alto_dip/2>
 }
 box{
  <-(largo_dip/2)-1,-ancho_dip/4,(alto_dip/2)-alto_vientre>
  < (largo_dip/2)-1, ancho_dip/4,(alto_dip/2)+1>
 }
 #declare cnt=1
 #while (cnt<=num_boton)
  box{
   <-largo_bot/2,-ancho_bot,-ancho_bot>
   < largo_bot/2, ancho_bot, ancho_bot>
   translate <-(largo_dip/2)+largo_bot+(largo_bot*2*cnt),0,-alto_dip/2>
  }
  #declare cnt=cnt+1
 #end
 texture{t_carcasa_dip}
}
#declare boton_dip_on=
union{
  box{
   <-largo_bot/2,-ancho_bot,-ancho_bot>
   < largo_bot/2, 0, ancho_bot>
  }
  box{
   <-largo_bot/2, 0,0.05>
   < largo_bot/2, ancho_bot, ancho_bot>
  }
  texture{t_boton_dip}
}
#declare boton_dip_off=
object{boton_dip_on
 rotate 180*z
}

#declare r1=seed(8)
#declare conmutador_dip=
union{
 object{ carcasa_dip }
 #declare cnt=1
 #while (cnt<=num_boton)
  #if (rand(r1)>0.5)
   object{boton_dip_on
   translate <-(largo_dip/2)+largo_bot+(largo_bot*2*cnt),0,-alto_dip/2>
   }
  #else
   object{boton_dip_off
   translate <-(largo_dip/2)+largo_bot+(largo_bot*2*cnt),0,-alto_dip/2>
   }
  #end
  #declare cnt=cnt+1
 #end
}

// **** fin conmutador dip ****

/*
  **** condensador c24 ****
*/
#declare radio_c24=0.25
#declare alt_c24=0.8
#declare long_pata_c24=0.5
#declare t_c24=
 texture{
  pigment{Orange/2+Tan/2}
  finish{Shiny reflection 0.1}
 }
#declare t_pata_c24=
 texture{Chrome_Texture}

#declare cuerpo_c24=
blob{threshold 0.5
 sphere{<0,0.26*2,0>,0.26*2,1}
 sphere{<0,0.26,0>,0.21*2,1}
 sphere{<0,0,0>,0.15*2,1}
}
#declare patas_c24=
union{
 cylinder{< 0.1,0,0>,< 0.1,-long_pata_c24,0>,0.01}
 cylinder{<-0.1,0,0>,<-0.1,-long_pata_c24,0>,0.01}
}
#declare c24=
union{
 object{cuerpo_c24
  texture{t_c24}
 }
 object{patas_c24
  texture{t_pata_c24}
 }
 scale 0.8
}

// **** fin condensador c24 ****

/*
  **** jumper basico ****
              Ŀ
           Ĵ
                0.6
               
     
          0.2
    
   0.2  0.4
*/
#declare alto_base_j=0.2
#declare ancho_base_j=0.4
#declare grosor_base_j=0.2
#declare alto_pin_j=0.6
#declare grueso_pin_j=0.05

#declare t_pin_j=
texture{Gold_Texture}
#declare t_base_j=
texture{
 pigment{Black}
 finish{Dull}
}

#declare base_j=
box{
 <-ancho_base_j/2,-alto_base_j/2,-grosor_base_j/2>
 < ancho_base_j/2, alto_base_j/2, grosor_base_j/2>
 texture{t_base_j}
}
#declare pin_j=
box{
 <-grueso_pin_j/2,-alto_pin_j/2,-grueso_pin_j/2>
 < grueso_pin_j/2, alto_pin_j/2, grueso_pin_j/2>
 texture{t_pin_j}
}
#declare puente_j=
box{
 <-ancho_base_j/2,-alto_pin_j/2,-grosor_base_j/2>
 < ancho_base_j/2, alto_pin_j/2, grosor_base_j/2>
 texture{t_base_j}
}

#declare jumper_a=
union{
 object{pin_j
  translate <-0.1,alto_base_j/2+alto_pin_j/2,0>
 }
 object{pin_j
  translate < 0.1,alto_base_j/2+alto_pin_j/2,0>
 }
 object{base_j
  translate (alto_base_j/2)*y
 }
 rotate -90*x
 rotate 90*z
}
#declare jumper_c=
union{
 object{pin_j
  translate <-0.1,alto_base_j/2+alto_pin_j/2,0>
 }
 object{pin_j
  translate < 0.1,alto_base_j/2+alto_pin_j/2,0>
 }
 object{base_j
  translate (alto_base_j/2)*y
 }
 object{puente_j
  translate (alto_base_j/2+alto_pin_j/2)*y
 }
 rotate -90*x
 rotate 90*z

}

// **** fin jumper ****

/*
  **** resistencia ****

*/
#declare largo_r=1.2

#declare t_r1=
 texture{
  pigment{
   gradient x
   color_map{
    [0.0 color Tan]
    [0.2 color Tan]
    [0.2 color Red]
    [0.24 color Red]
    [0.24 color Tan]
    [0.3 color Tan]
    [0.3 color Blue]
    [0.34 color Blue]
    [0.34 color Tan]
    [0.4 color Tan]
    [0.4 color Violet]
    [0.44 color Violet]
    [0.44 color Tan]
    [0.8 color Tan]
    [0.8 color White]
    [0.84 color White]
    [0.84 color Tan]
    [1.0 color Tan]
   }
   turbulence 0
   scale 0.5
   translate 0.5*x
  }
  finish{Shiny reflection 0.1}
 }
#declare t_r2=
 texture{
  pigment{
   gradient x
   color_map{
    [0.0 color Flesh]
    [0.2 color Flesh]
    [0.2 color Brown]
    [0.24 color Brown]
    [0.24 color Flesh]
    [0.3 color Flesh]
    [0.3 color Green]
    [0.34 color Green]
    [0.34 color Flesh]
    [0.4 color Flesh]
    [0.4 color Gold]
    [0.44 color Gold]
    [0.44 color Flesh]
    [0.8 color Flesh]
    [0.8 color Yellow]
    [0.84 color Yellow]
    [0.84 color Flesh]
    [1.0 color Flesh]
   }
   turbulence 0
   scale 0.5
   translate 0.5*x
  }
  finish{Shiny reflection 0.1}
 }
#declare t_r3=
 texture{
  pigment{
   gradient x
   color_map{
    [0.0 color SteelBlue]
    [0.2 color SteelBlue]
    [0.2 color White]
    [0.24 color White]
    [0.24 color SteelBlue]
    [0.3 color SteelBlue]
    [0.3 color Orange]
    [0.34 color Orange]
    [0.34 color SteelBlue]
    [0.4 color SteelBlue]
    [0.4 color Red]
    [0.44 color Red]
    [0.44 color SteelBlue]
    [0.8 color SteelBlue]
    [0.8 color Yellow]
    [0.84 color Yellow]
    [0.84 color SteelBlue]
    [1.0 color SteelBlue]
   }
   turbulence 0
   scale 0.5
   translate 0.5*x
  }
  finish{Shiny reflection 0.1}
 }
#declare t_r4=
 texture{
  pigment{
   gradient x
   color_map{
    [0.0 color Violet]
    [0.2 color Violet]
    [0.2 color White]
    [0.24 color White]
    [0.24 color Violet]
    [0.3 color Violet]
    [0.3 color OrangeRed]
    [0.34 color OrangeRed]
    [0.34 color Violet]
    [0.4 color Violet]
    [0.4 color SkyBlue]
    [0.44 color SkyBlue]
    [0.44 color Violet]
    [0.8 color Violet]
    [0.8 color White]
    [0.84 color White]
    [0.84 color Violet]
    [1.0 color Violet]
   }
   turbulence 0
   scale 0.5
   translate 0.5*x
  }
  finish{Shiny reflection 0.1}
 }

#declare t_pata_r=
 texture{Chrome_Texture}

#declare pata_r=
intersection{
 torus{0.5,0.08}
 plane{x,0}
 scale 0.3
 texture{t_pata_r}
}
#declare cuerpo_r=
 blob{threshold 0.5
  sphere{<-largo_r/2,0,0>,1,1}
  sphere{< largo_r/2,0,0>,1,1}
  sphere{< largo_r/4,0,0>,0.7,1}
  sphere{<-largo_r/4,0,0>,0.7,1}
 }

#declare resist01=
union{
 object{cuerpo_r
  texture{t_r1}
  scale <0.3,0.25,0.25>
 }
 object{pata_r
  translate <(-largo_r/2)*0.4,0,0.15>
 }
 object{pata_r
  rotate 180*z
  translate <(largo_r/2)*0.4,0,0.15>
 }
}
#declare resist02=
union{
 object{cuerpo_r
  texture{t_r2}
  scale <0.3,0.25,0.25>
 }
 object{pata_r
  translate <(-largo_r/2)*0.4,0,0.15>
 }
 object{pata_r
  rotate 180*z
  translate <(largo_r/2)*0.4,0,0.15>
 }
}
#declare resist03=
union{
 object{cuerpo_r
  texture{t_r3}
  scale 0.2
 }
 object{pata_r
  translate <(-largo_r/2)*0.3,0,0.15>
 }
 object{pata_r
  rotate 180*z
  translate <(largo_r/2)*0.3,0,0.15>
 }
}
#declare resist04=
union{
 object{cuerpo_r
  texture{t_r4}
  scale 0.25
 }
 object{pata_r
  translate <(-largo_r/2)*0.3,0,0.15>
 }
 object{pata_r
  rotate 180*z
  translate <(largo_r/2)*0.3,0,0.15>
 }
}
// **** fin resistencia ****

/*
  **** 72pr10k ****
  resistencia variable?
*/
#declare lado_72=1
#declare alto_72=0.5
#declare radio_72=0.18
#declare ranura_72=0.08

#declare t_72=
texture{
 pigment{White}
 finish{reflection 0.1}
}
#declare t_lacra=
texture{
 pigment{Firebrick}
 finish{Shiny reflection 0.2}
}

#declare torn_72=
difference{
 cylinder{
  <0,0,-alto_72/2>
  <0,0,alto_72/2>
  radio_72
 }
 box{
  <-radio_72*2,-ranura_72/2,alto_72/2-ranura_72>
  <-radio_72*2,-ranura_72/2,alto_72/2+ranura_72>
  rotate 30*z
 }
}
#declare cuerpo_72=
difference{
 box{
  <-lado_72/2,-lado_72/2,-alto_72/2>
  < lado_72/2, lado_72/2, alto_72/2>
 }
 object{torn_72
  translate (-ranura_72*2)*z
 }
}
//#declare lacra_72=

#declare R72pr10k=
union{
 object{cuerpo_72
  texture{t_72}
 }
 object{torn_72
  texture{t_lacra}
 }
// object{lacra_72
//  texture{t_lacra}
// }
}

// **** fin 72pr10k ****

/*
 **** reloj toyocom tco-711a 2.200 mhz (japan) ****
*/
#declare largo_tco=1.8
#declare ancho_tco=1
#declare alto_tco=0.6
#declare borde_tco=0.08

#declare t_reloj=
texture{
 material_map{
  gif "i_tco.gif"
  texture{pigment{Black}}
  texture{Silver_Texture}
 }
 translate <-.5,-.5,0>
 scale <76*0.5/22,23/22,1>
}

#declare cuerpo_tco=
superellipsoid{
 <0.1,0.1>
 scale <largo_tco/2,ancho_tco/2,alto_tco/2>
}
#declare tco_borde=
intersection{
 object{cuerpo_tco
  scale (((borde_tco+largo_tco)*0.5)/(largo_tco*0.5))
 }
 plane{z,-borde_tco}
}

#declare reloj_tco=
union{
 object{cuerpo_tco}
 object{tco_borde}
 texture{t_reloj}
}

// **** fin reloj ****

/*
  **** condensador plano ***
*/
#declare t_con_plan=
texture{
 pigment{Orange}
 finish{Phong_Shiny reflection 0.2}
}

#declare con_plan=
union{
 object{cuerpo_c24
  scale <1,1,0.2>
  texture{t_con_plan}
 }
 object{patas_c24
  texture{t_pata_c24}
 }
 scale 0.7
 rotate -90*x
}

// **** fin condensador plano ****

/*
  **** condensador cilindrico ****
*/
#declare alto_cc=0.8
#declare radio_cc=0.3
#declare t_cc=
texture{
 pigment{SkyBlue}
 finish{F_MetalA}
}

#declare con_cil=
superellipsoid{ <1,0.1>
 scale <radio_cc,radio_cc,-alto_cc/2>
 texture{t_cc}
}

// **** fin condensador cilindrico ****
